Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoVRMLMovieTexture Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLMovieTexture.h>`

Inheritance diagram for SoVRMLMovieTexture:

List of all members.

## Detailed Description

The SoVRMLMovieTexture class is used the map movies onto geometry.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      MovieTexture {
        exposedField SFBool   loop             FALSE
        exposedField SFFloat  speed            1.0      # (-inf, inf)
        exposedField SFTime   startTime        0        # (-inf, inf)
        exposedField SFTime   stopTime         0        # (-inf, inf)
        exposedField MFString url              []
        field        SFBool   repeatS          TRUE
        field        SFBool   repeatT          TRUE
        eventOut     SFTime   duration_changed
        eventOut     SFBool   isActive
      }

The MovieTexture node defines a time dependent texture map (contained in a movie file) and parameters for controlling the movie and the texture mapping. A MovieTexture node can also be used as the source of sound data for a Sound node. In this special case, the MovieTexture node is not used for rendering.

Texture maps are defined in a 2D coordinate system (s, t) that ranges from 0.0 to 1.0 in both directions. The bottom edge of the image corresponds to the S-axis of the texture map, and left edge of the image corresponds to the T-axis of the texture map. The lower-left pixel of the image corresponds to s=0.0, t=0.0, and the top-right pixel of the image corresponds to s=1.0, t=1.0. Figure 6.12 depicts the texture map coordinate system of the MovieTexture.

Figure 6.12 -- MovieTexture node coordinate system

The url field that defines the movie data shall support MPEG1-Systems (audio and video) or MPEG1-Video (video-only) movie file formats 2 Details on the url field can be found in 4.5, VRML and the World Wide Web (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.5>). MovieTexture nodes can be referenced by an Appearance node's texture field (as a movie texture) and by a Sound node's source field (as an audio source only). See 4.6.11, Texture maps (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.11>), for a general description of texture maps. 4.14, Lighting model (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.14>), contains details on lighting equations and the interaction between textures, materials, and geometries.

As soon as the movie is loaded, a duration_changed eventOut is sent. This indicates the duration of the movie in seconds. This eventOut value can be read (for instance, by a Script node) to determine the duration of a movie. A value of "-1" implies the movie has not yet loaded or the value is unavailable for some reason.

The loop, startTime, and stopTime exposedFields and the isActive eventOut, and their effects on the MovieTexture node, are discussed in detail in the 4.6.9, Time-dependent nodes, section (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.9>).

The cycle of a MovieTexture node is the length of time in seconds for one playing of the movie at the specified speed. The speed exposedField indicates how fast the movie shall be played. A speed of 2 indicates the movie plays twice as fast. The duration_changed output is not affected by the speed exposedField. set_speed events are ignored while the movie is playing. A negative speed implies that the movie will play backwards.

If a MovieTexture node is inactive when the movie is first loaded, frame 0 of the movie texture is displayed if speed is non-negative or the last frame of the movie texture is shown if speed is negative (see 4.11.3, Discrete and continuous changes). A MovieTexture node shall display frame 0 if speed = 0. For positive values of speed, an active MovieTexture node displays the frame at movie time t as follows (i.e., in the movie's local time system with frame 0 at time 0 with speed = 1):

        t = (now - startTime) modulo (duration/speed)

If speed is negative, the MovieTexture node displays the frame at movie time:

        t = duration - ((now - startTime) modulo |duration/speed|)

When a MovieTexture node becomes inactive, the frame corresponding to the time at which the MovieTexture became inactive will remain as the texture.

## Public Member Functions
| SoVRMLMovieTexture (void)
virtual void | GLRender (SoGLRenderAction *action)
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFBool | loop
SoSFFloat | speed
SoSFTime | startTime
SoSFTime | stopTime
SoMFString | url
SoSFTime | duration_changed
SoSFBool | isActive
## Protected Member Functions
virtual | ~SoVRMLMovieTexture ()

## Constructor & Destructor Documentation

SoVRMLMovieTexture::SoVRMLMovieTexture | ( | void |  | ) |

| Constructor.

SoVRMLMovieTexture::~SoVRMLMovieTexture | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLMovieTexture::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLTexture.

void SoVRMLMovieTexture::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoVRMLTexture.

## Member Data Documentation

SoSFBool SoVRMLMovieTexture::loop

| Specifies whether movie should be looped or not. Default value is FALSE.

SoSFFloat SoVRMLMovieTexture::speed

| Specifies the relative speed. Default value is 1.0.

SoSFTime SoVRMLMovieTexture::startTime

| Specifies the start time.

SoSFTime SoVRMLMovieTexture::stopTime

| Specifies the stop time.

SoMFString SoVRMLMovieTexture::url

| The filename URL.

SoSFTime SoVRMLMovieTexture::duration_changed

| An eventOut that is signaled after the node is loaded or inserted in the scene graph.

SoSFBool SoVRMLMovieTexture::isActive

| An eventOut that is signaled when the movie begins/finishes playing.

The documentation for this class was generated from the following files:

- SoVRMLMovieTexture.h
- MovieTexture.cpp